Codeforces Round #286 (Div. 1) D. Mr. Kitayuta's Colorful Graph 并查集

时间:2023-03-08 16:18:12
Codeforces Round #286 (Div. 1) D. Mr. Kitayuta's Colorful Graph 并查集

D. Mr. Kitayuta's Colorful Graph

Time Limit: 20 Sec

Memory Limit: 256 MB

题目连接

http://codeforces.com/contest/506/problem/D

Description

Mr. Kitayuta has just bought an undirected graph with n vertices and m edges. The vertices of the graph are numbered from 1 to n. Each edge, namely edge i, has a color ci, connecting vertex ai and bi.

Mr. Kitayuta wants you to process the following q queries.

In the i-th query, he gives you two integers - ui and vi.

Find the number of the colors that satisfy the following condition: the edges of that color connect vertex ui and vertex vi directly or indirectly.

Under two situations the player could score one point.

⋅1. If you touch a buoy before your opponent, you will get one point. For example if your opponent touch the buoy #2 before you after start, he will score one point. So when you touch the buoy #2, you won't get any point. Meanwhile, you cannot touch buoy #3 or any other buoys before touching the buoy #2.

⋅2. Ignoring the buoys and relying on dogfighting to get point.
If you and your opponent meet in the same position, you can try to
fight with your opponent to score one point. For the proposal of game
balance, two players are not allowed to fight before buoy #2 is touched by anybody.

There are three types of players.

Speeder:
As a player specializing in high speed movement, he/she tries to avoid
dogfighting while attempting to gain points by touching buoys.
Fighter:
As a player specializing in dogfighting, he/she always tries to fight
with the opponent to score points. Since a fighter is slower than a
speeder, it's difficult for him/her to score points by touching buoys
when the opponent is a speeder.
All-Rounder: A balanced player between Fighter and Speeder.

There will be a training match between Asuka (All-Rounder) and Shion (Speeder).
Since the match is only a training match, the rules are simplified: the game will end after the buoy #1 is touched by anybody. Shion is a speed lover, and his strategy is very simple: touch buoy #2,#3,#4,#1 along the shortest path.

Asuka is good at dogfighting, so she will always score one point by dogfighting with Shion, and the opponent will be stunned for T seconds after dogfighting.
Since Asuka is slower than Shion, she decides to fight with Shion for
only one time during the match. It is also assumed that if Asuka and
Shion touch the buoy in the same time, the point will be given to Asuka
and Asuka could also fight with Shion at the buoy. We assume that in
such scenario, the dogfighting must happen after the buoy is touched by
Asuka or Shion.

The speed of Asuka is V1 m/s. The speed of Shion is V2 m/s. Is there any possibility for Asuka to win the match (to have higher score)?

Input

The first line of the input contains space-separated two integers - n and m(2 ≤ n ≤ 105, 1 ≤ m ≤ 105), denoting the number of the vertices and the number of the edges, respectively.

The next m lines contain space-separated three integers - ai, bi(1 ≤ ai < bi ≤ n) and ci(1 ≤ ci ≤ m). Note that there can be multiple edges between two vertices. However, there are no multiple edges of the same color between two vertices, that is, if i ≠ j, (ai, bi, ci) ≠ (aj, bj, cj).

The next line contains a integer- q(1 ≤ q ≤ 105), denoting the number of the queries.

Then follows q lines, containing space-separated two integers - ui and vi(1 ≤ ui, vi ≤ n). It is guaranteed that ui ≠ vi.

Output

For each query, print the answer in a separate line.

Sample Input

4 5
1 2 1
1 2 2
2 3 1
2 3 3
2 4 3
3
1 2
3 4
1 4

Sample Output

2
1
0

HINT

题意

给你一个图,然后有重边,每条边有一种颜色,然后每次查询两个点之间有多少种颜色是把这俩点直接相连的

题解:

每种颜色都直接用并查集来维护就好了

用map,就可以没必要初始化了

代码

#include<iostream>
#include<stdio.h>
#include<unordered_map>
using namespace std;
#define maxn 100007
unordered_map<int,int> H[maxn],ans[maxn]; int fi(int x,int y)
{
return x==H[x][y]?x:H[x][y]=fi(H[x][y],y);
}
void uni(int x,int y,int c)
{
if(H[x].find(c)==H[x].end())H[x][c]=x;
if(H[y].find(c)==H[y].end())H[y][c]=y;
int p = fi(x,c),q = fi(y,c);
if(p==q)return;
if(p>q)swap(p,q);
H[fi(x,c)][c]=fi(y,c);
} int main()
{
int n,m;scanf("%d%d",&n,&m);
for(int i=;i<=m;i++)
{
int x,y,z;
scanf("%d%d%d",&x,&y,&z);
if(x>y)swap(x,y);
uni(x,y,z);
}
int q;scanf("%d",&q);
while(q--)
{
int x,y;scanf("%d%d",&x,&y);
if(H[x].size()>H[y].size())swap(x,y);
if(ans[x].find(y)==ans[x].end())
{
int Ans = ;
for(auto &c:H[x])
{
if(H[y].find(c.first)==H[y].end())continue;
int p = fi(x,c.first),q = fi(y,c.first);
if(p==q)Ans++;
}
ans[x][y] = Ans;
}
printf("%d\n",ans[x][y]);
}
}